Index: frontends/php/include/triggers.inc.php
===================================================================
--- frontends/php/include/triggers.inc.php	(revision 38884)
+++ frontends/php/include/triggers.inc.php	(working copy)
@@ -311,7 +311,7 @@
 	function get_service_status_of_trigger($triggerid){
 		$sql = 'SELECT triggerid, priority '.
 				' FROM triggers '.
-				' WHERE triggerid='.$triggerid.
+				' WHERE triggerid='.zbx_dbstr($triggerid).
 					' AND status='.TRIGGER_STATUS_ENABLED.
 					' AND value='.TRIGGER_VALUE_TRUE;
 
@@ -470,7 +470,7 @@
 	}
 
 	function get_trigger_by_triggerid($triggerid){
-		$sql='select * from triggers where triggerid='.$triggerid;
+		$sql='select * from triggers where triggerid='.zbx_dbstr($triggerid);
 		$result=DBselect($sql);
 		$row=DBfetch($result);
 		if($row){
@@ -491,7 +491,7 @@
 	}
 
 	function get_functions_by_triggerid($triggerid){
-		return DBselect('select * from functions where triggerid='.$triggerid);
+		return DBselect('select * from functions where triggerid='.zbx_dbstr($triggerid));
 	}
 
 /*
@@ -509,7 +509,7 @@
 	function get_triggers_by_hostid($hostid){
 		$db_triggers = DBselect('SELECT DISTINCT t.* '.
 								' FROM triggers t, functions f, items i '.
-								' WHERE i.hostid='.$hostid.
+								' WHERE i.hostid='.zbx_dbstr($hostid).
 									' AND f.itemid=i.itemid '.
 									' AND f.triggerid=t.triggerid');
 	return $db_triggers;
@@ -851,8 +851,8 @@
 
 		$result=DBexecute('INSERT INTO triggers '.
 			'  (triggerid,description,type,priority,status,comments,url,value,error,templateid) '.
-			" values ($triggerid,".zbx_dbstr($description).",$type,$priority,$status,".zbx_dbstr($comments).','.
-			zbx_dbstr($url).",2,'Trigger just added. No status update so far.',$templateid)");
+			' values ('.$triggerid.','.zbx_dbstr($description).','.zbx_dbstr($type).','.zbx_dbstr($priority).','.zbx_dbstr($status).','.zbx_dbstr($comments).','.
+			zbx_dbstr($url).',2,\'Trigger just added. No status update so far.\','.zbx_dbstr($templateid).')');
 
 		if(!$result){
 			return	$result;
@@ -866,7 +866,7 @@
 
 
 		if($result){
-			DBexecute('update triggers set expression='.zbx_dbstr($expression).' where triggerid='.$triggerid);
+			DBexecute('update triggers set expression='.zbx_dbstr($expression).' where triggerid='.zbx_dbstr($triggerid));
 
 			foreach($deps as $id => $triggerid_up){
 				if(!$result2=add_trigger_dependency($triggerid, $triggerid_up)){
@@ -924,13 +924,13 @@
 					// $hostid);
 		$sql='SELECT t2.triggerid, t2.expression '.
 				' FROM triggers t2, functions f1, functions f2, items i1, items i2 '.
-				' WHERE f1.triggerid='.$triggerid.
+				' WHERE f1.triggerid='.zbx_dbstr($triggerid).
 					' AND i1.itemid=f1.itemid '.
 					' AND f2.function=f1.function '.
 					' AND f2.parameter=f1.parameter '.
 					' AND i2.itemid=f2.itemid '.
 					' AND i2.key_=i1.key_ '.
-					' AND i2.hostid='.$hostid.
+					' AND i2.hostid='.zbx_dbstr($hostid).
 					' AND t2.triggerid=f2.triggerid '.
 					' AND t2.description='.zbx_dbstr($trigger['description']).
 					' AND t2.templateid=0 ';
@@ -957,9 +957,9 @@
 
 		$result = DBexecute('INSERT INTO triggers '.
 					' (triggerid,description,type,priority,status,comments,url,value,expression,templateid)'.
-					' VALUES ('.$newtriggerid.','.zbx_dbstr($trigger['description']).','.$trigger['type'].','.$trigger['priority'].','.
-					$trigger['status'].','.zbx_dbstr($trigger['comments']).','.
-					zbx_dbstr($trigger['url']).",2,'0',".($copy_mode ? 0 : $triggerid).')');
+					' VALUES ('.$newtriggerid.','.zbx_dbstr($trigger['description']).','.zbx_dbstr($trigger['type']).','.zbx_dbstr($trigger['priority']).','.
+					zbx_dbstr($trigger['status']).','.zbx_dbstr($trigger['comments']).','.
+					zbx_dbstr($trigger['url']).",2,'0',".($copy_mode ? 0 : zbx_dbstr($triggerid)).')');
 
 		if(!$result)
 			return $result;
@@ -972,7 +972,7 @@
 		while($function = DBfetch($functions)){
 			$item = get_item_by_itemid($function['itemid']);
 
-			$host_items = DBselect('SELECT * FROM items WHERE key_='.zbx_dbstr($item['key_']).' AND hostid='.$host['hostid']);
+			$host_items = DBselect('SELECT * FROM items WHERE key_='.zbx_dbstr($item['key_']).' AND hostid='.zbx_dbstr($host['hostid']));
 			$host_item = DBfetch($host_items);
 			if(!$host_item){
 				error(S_MISSING_KEY.SPACE.'"'.$item['key_'].'"'.SPACE.S_FOR_HOST_SMALL.SPACE.'"'.$host['host'].'"');
@@ -982,7 +982,7 @@
 			$newfunctionid=get_dbid('functions','functionid');
 
 			$result = DBexecute('INSERT INTO functions (functionid,itemid,triggerid,function,parameter) '.
-				" values ($newfunctionid,".$host_item['itemid'].','.$newtriggerid.','.
+				' values ('.zbx_dbstr($newfunctionid).','.zbx_dbstr($host_item['itemid']).','.zbx_dbstr($newtriggerid).','.
 				zbx_dbstr($function['function']).','.zbx_dbstr($function['parameter']).')');
 
 			$newexpression = str_replace(
@@ -991,7 +991,7 @@
 				$newexpression);
 		}
 
-		DBexecute('UPDATE triggers SET expression='.zbx_dbstr($newexpression).' WHERE triggerid='.$newtriggerid);
+		DBexecute('UPDATE triggers SET expression='.zbx_dbstr($newexpression).' WHERE triggerid='.zbx_dbstr($newtriggerid));
 // copy dependencies
 		// delete_dependencies_by_triggerid($newtriggerid);
 		$deps = replace_template_dependencies(get_trigger_dependencies_by_triggerid($triggerid),$hostid);
@@ -1181,7 +1181,7 @@
 				$state='';
 				$sql = 'SELECT h.host,i.itemid,i.key_,f.function,f.triggerid,f.parameter,i.itemid,i.status'.
 						' FROM items i,functions f,hosts h'.
-						' WHERE f.functionid='.$functionid.
+						' WHERE f.functionid='.zbx_dbstr($functionid).
 							' AND i.itemid=f.itemid '.
 							' AND h.hostid=i.hostid';
 
@@ -1413,7 +1413,7 @@
 				$functionid = get_dbid('functions','functionid');
 
 				if( !DBexecute('insert into functions (functionid,itemid,triggerid,function,parameter)'.
-					' values ('.$functionid.','.$itemid.','.$triggerid.','.zbx_dbstr($function).','.
+					' values ('.$functionid.','.$itemid.','.zbx_dbstr($triggerid).','.zbx_dbstr($function).','.
 					zbx_dbstr($parameter).')'))
 				{
 					return	null;
@@ -1452,7 +1452,7 @@
 
 		add_event($triggerids,TRIGGER_VALUE_UNKNOWN);
 
-	return DBexecute('UPDATE triggers SET status='.$status.' WHERE '.DBcondition('triggerid',$triggerids));
+	return DBexecute('UPDATE triggers SET status='.zbx_dbstr($status).' WHERE '.DBcondition('triggerid',$triggerids));
 	}
 
 	/*
@@ -1556,12 +1556,12 @@
 							$description = str_replace($macro, $triggerData['lastvalue'], $description);
 						}
 						else{
-							$sql = 'SELECT MAX(clock) as max FROM history_log WHERE itemid='.$triggerData['itemid'];
+							$sql = 'SELECT MAX(clock) as max FROM history_log WHERE itemid='.zbx_dbstr($triggerData['itemid']);
 							$trigger3=DBfetch(DBselect($sql));
 							if($trigger3 && !is_null($trigger3['max'])){
 								$sql = 'SELECT value '.
 										' FROM history_log '.
-										' WHERE itemid='.$triggerData['itemid'].
+										' WHERE itemid='.zbx_dbstr($triggerData['itemid']).
 											' AND clock='.$trigger3['max'];
 								$trigger4=DBfetch(DBselect($sql));
 								$description = str_replace($macro, $trigger4['value'], $description);
@@ -1636,12 +1636,12 @@
 							$description = str_replace($macro, $triggerData['lastvalue'], $description);
 						}
 						else{
-							$sql = 'SELECT MAX(clock) as max FROM history_log WHERE itemid='.$triggerData['itemid'];
+							$sql = 'SELECT MAX(clock) as max FROM history_log WHERE itemid='.zbx_dbstr($triggerData['itemid']);
 							$trigger3=DBfetch(DBselect($sql));
 							if($trigger3 && !is_null($trigger3['max'])){
 								$sql = 'SELECT value '.
 										' FROM history_log '.
-										' WHERE itemid='.$triggerData['itemid'].
+										' WHERE itemid='.zbx_dbstr($triggerData['itemid']).
 											' AND clock='.$trigger3['max'];
 								$trigger4=DBfetch(DBselect($sql));
 								$description = str_replace($macro, $trigger4['value'], $description);
@@ -1756,7 +1756,7 @@
 				' WHERE f.triggerid=t.triggerid '.
 					' AND i.itemid=f.itemid '.
 					' AND h.hostid=i.hostid '.
-					' AND t.triggerid='.$triggerid;
+					' AND t.triggerid='.zbx_dbstr($triggerid);
 		$trigger = DBfetch(DBselect($sql));
 
 	return expand_trigger_description_by_data($trigger);
@@ -1788,7 +1788,7 @@
 		}
 
 		if(!empty($triggers)){
-			DBexecute('UPDATE triggers SET value='.TRIGGER_VALUE_UNKNOWN.', lastchange='.$now.' WHERE '.DBcondition('triggerid',$triggers));
+			DBexecute('UPDATE triggers SET value='.TRIGGER_VALUE_UNKNOWN.', lastchange='.zbx_dbstr($now).' WHERE '.DBcondition('triggerid',$triggers));
 		}
 	return true;
 	}
@@ -1814,7 +1814,7 @@
 		foreach($triggerids as $id => $triggerid){
 			$eventid = get_dbid('events','eventid');
 			$result = DBexecute('INSERT INTO events (eventid,source,object,objectid,clock,value) '.
-					' VALUES ('.$eventid.','.EVENT_SOURCE_TRIGGERS.','.EVENT_OBJECT_TRIGGER.','.$triggerid.','.$time.','.$value.')');
+					' VALUES ('.$eventid.','.EVENT_SOURCE_TRIGGERS.','.EVENT_OBJECT_TRIGGER.','.zbx_dbstr($triggerid).','.$time.','.zbx_dbstr($value).')');
 			$events[$eventid] = $eventid;
 		}
 
@@ -2018,13 +2018,13 @@
 		$sql='UPDATE triggers SET ';
 		if(!is_null($expression))	$sql .= ' expression='.zbx_dbstr($expression).',';
 		if(!is_null($description))	$sql .= ' description='.zbx_dbstr($description).',';
-		if(!is_null($type))			$sql .= ' type='.$type.',';
-		if(!is_null($priority))		$sql .= ' priority='.$priority.',';
-		if(!is_null($status))		$sql .= ' status='.$status.',';
+		if(!is_null($type))			$sql .= ' type='.zbx_dbstr($type).',';
+		if(!is_null($priority))		$sql .= ' priority='.zbx_dbstr($priority).',';
+		if(!is_null($status))		$sql .= ' status='.zbx_dbstr($status).',';
 		if(!is_null($comments))		$sql .= ' comments='.zbx_dbstr($comments).',';
 		if(!is_null($url))			$sql .= ' url='.zbx_dbstr($url).',';
-		if(!is_null($templateid))	$sql .= ' templateid='.$templateid.',';
-		$sql .= ' value=2 WHERE triggerid='.$triggerid;
+		if(!is_null($templateid))	$sql .= ' templateid='.zbx_dbstr($templateid).',';
+		$sql .= ' value=2 WHERE triggerid='.zbx_dbstr($triggerid);
 
 		$result = DBexecute($sql);
 
@@ -2058,7 +2058,7 @@
 	}
 
 	function check_right_on_trigger_by_triggerid($permission,$triggerid){
-		$trigger_data = DBfetch(DBselect('select expression from triggers where triggerid='.$triggerid));
+		$trigger_data = DBfetch(DBselect('select expression from triggers where triggerid='.zbx_dbstr($triggerid)));
 
 		if(!$trigger_data) return false;
 
@@ -2088,7 +2088,7 @@
 	function get_trigger_dependencies_by_triggerid($triggerid){
 		$result = array();
 
-		$db_deps = DBselect('SELECT * FROM trigger_depends WHERE triggerid_down='.$triggerid);
+		$db_deps = DBselect('SELECT * FROM trigger_depends WHERE triggerid_down='.zbx_dbstr($triggerid));
 		while($db_dep = DBfetch($db_deps))
 			$result[] = $db_dep['triggerid_up'];
 
@@ -2114,11 +2114,11 @@
 
 		$triggerdepid = get_dbid('trigger_depends','triggerdepid');
 		$result=DBexecute('INSERT INTO trigger_depends (triggerdepid,triggerid_down,triggerid_up) '.
-							" VALUES ($triggerdepid,$triggerid_down,$triggerid_up)");
+							" VALUES ($triggerdepid,".zbx_dbstr($triggerid_down).",".zbx_dbstr($triggerid_up).")");
 		if(!$result){
 			return	$result;
 		}
-	return DBexecute('UPDATE triggers SET dep_level=dep_level+1 WHERE triggerid='.$triggerid_up);
+	return DBexecute('UPDATE triggers SET dep_level=dep_level+1 WHERE triggerid='.zbx_dbstr($triggerid_up));
 	}
 
 /*
@@ -2139,7 +2139,7 @@
 
 		$sql = 'SELECT DISTINCT t.triggerid, t.templateid '.
 							' FROM triggers t, functions f, items i '.
-							' WHERE i.hostid='.$hostid.
+							' WHERE i.hostid='.zbx_dbstr($hostid).
 								' AND f.itemid=i.itemid '.
 								' AND f.triggerid=t.triggerid '.
 								' AND t.templateid > 0';
@@ -2153,7 +2153,7 @@
 
 		$sql = 'SELECT DISTINCT td.* '.
 				' FROM items i, functions f, triggers t, trigger_depends td '.
-				' WHERE i.hostid='.$hostid.
+				' WHERE i.hostid='.zbx_dbstr($hostid).
 					' AND f.itemid=i.itemid '.
 					' AND t.triggerid=f.triggerid '.
 					' AND ( (td.triggerid_up=t.templateid) OR (td.triggerid_down=t.templateid) )';
@@ -2229,10 +2229,10 @@
 		foreach($deps as $id => $val){
 			$sql = 'SELECT t.triggerid '.
 				' FROM triggers t,functions f,items i '.
-				' WHERE t.templateid='.$val.
+				' WHERE t.templateid='.zbx_dbstr($val).
 					' AND f.triggerid=t.triggerid '.
 					' AND f.itemid=i.itemid '.
-					' AND i.hostid='.$hostid;
+					' AND i.hostid='.zbx_dbstr($hostid);
 			if($db_new_dep = DBfetch(DBselect($sql))){
 				$deps[$id] = $db_new_dep['triggerid'];
 			}
@@ -2269,7 +2269,7 @@
 		$level++;
 		$result = true;
 
-		$sql = 'SELECT triggerid_up FROM trigger_depends WHERE triggerid_down='.$triggerid_up;
+		$sql = 'SELECT triggerid_up FROM trigger_depends WHERE triggerid_down='.zbx_dbstr($triggerid_up);
 		$res = DBselect($sql);
 		while(($trig = DBfetch($res)) && $result){
 			$result &= check_dependency_by_triggerid($triggerid,$trig['triggerid_up'],$level);		// RECURSION!!!
@@ -2296,7 +2296,7 @@
 						' OR ('.DBcondition('td.triggerid_up',$triggerids).' AND f.triggerid=td.triggerid_down)) '.
 						' AND i.itemid=f.itemid '.
 						' AND h.hostid=i.hostid '.
-						' AND h.hostid<>'.$templateid.
+						' AND h.hostid<>'.zbx_dbstr($templateid).
 						' AND h.status='.HOST_STATUS_TEMPLATE;
 
 			$db_dephosts = DBselect($sql);
@@ -2701,7 +2701,7 @@
 			$sql = 'SELECT DISTINCT i.itemid, i.description, i.key_, i.value_type '.
 					' FROM items i, functions f '.
 					' WHERE f.itemid=i.itemid '.
-						' AND f.triggerid='.$trhosts[$hostname]['triggerid'];
+						' AND f.triggerid='.zbx_dbstr($trhosts[$hostname]['triggerid']);
 			$db_items = DBselect($sql);
 			while($item_data = DBfetch($db_items)){
 				$description = item_description($item_data);
@@ -2756,7 +2756,7 @@
 			$dep_table->setAttribute('style', 'width: 200px;');
 			$dep_table->addRow(bold(S_DEPENDS_ON.':'));
 
-			$sql_dep = 'SELECT * FROM trigger_depends WHERE triggerid_down='.$triggerid;
+			$sql_dep = 'SELECT * FROM trigger_depends WHERE triggerid_down='.zbx_dbstr($triggerid);
 			$dep_res = DBselect($sql_dep);
 			while($dep_row = DBfetch($dep_res)){
 				$dep_table->addRow(SPACE.'-'.SPACE.expand_trigger_description($dep_row['triggerid_up']));
@@ -2778,7 +2778,7 @@
 			$dep_table->setAttribute('style', 'width: 200px;');
 			$dep_table->addRow(bold(S_DEPENDENT.':'));
 
-			$sql_dep = 'SELECT * FROM trigger_depends WHERE triggerid_up='.$triggerid;
+			$sql_dep = 'SELECT * FROM trigger_depends WHERE triggerid_up='.zbx_dbstr($triggerid);
 			$dep_res = DBselect($sql_dep);
 			while($dep_row = DBfetch($dep_res)){
 				$dep_table->addRow(SPACE.'-'.SPACE.expand_trigger_description($dep_row['triggerid_down']));
@@ -2813,7 +2813,7 @@
 	}
 
 	function get_function_by_functionid($functionid){
-		$result=DBselect('SELECT * FROM functions WHERE functionid='.$functionid);
+		$result=DBselect('SELECT * FROM functions WHERE functionid='.zbx_dbstr($functionid));
 		$row=DBfetch($result);
 		if($row){
 			return	$row;
@@ -2830,9 +2830,9 @@
 		if(($period_start>0) && ($period_start < time())){
 			$sql='SELECT e.eventid, e.value '.
 					' FROM events e '.
-					' WHERE e.objectid='.$triggerid.
+					' WHERE e.objectid='.zbx_dbstr($triggerid).
 						' AND e.object='.EVENT_OBJECT_TRIGGER.
-						' AND e.clock<'.$period_start.
+						' AND e.clock<'.zbx_dbstr($period_start).
 					' ORDER BY e.eventid DESC';
 			if($row = DBfetch(DBselect($sql,1))){
 				$start_value = $row['value'];
@@ -2842,11 +2842,11 @@
 
 		$sql='SELECT COUNT(*) as cnt, MIN(clock) as minn, MAX(clock) as maxx '.
 				' FROM events '.
-				' WHERE objectid='.$triggerid.
+				' WHERE objectid='.zbx_dbstr($triggerid).
 					' AND object='.EVENT_OBJECT_TRIGGER;
 
-		if($period_start!=0)	$sql .= ' AND clock>='.$period_start;
-		if($period_end!=0)		$sql .= ' AND clock<='.$period_end;
+		if($period_start!=0)	$sql .= ' AND clock>='.zbx_dbstr($period_start);
+		if($period_end!=0)		$sql .= ' AND clock<='.zbx_dbstr($period_end);
 //SDI($sql);
 
 		$row=DBfetch(DBselect($sql));
@@ -2886,10 +2886,10 @@
 		$rows=0;
 		$sql = 'SELECT eventid,clock,value '.
 				' FROM events '.
-				' WHERE objectid='.$triggerid.
+				' WHERE objectid='.zbx_dbstr($triggerid).
 					' AND object='.EVENT_OBJECT_TRIGGER.
-					' AND clock>='.$min.
-					' AND clock<='.$max.
+					' AND clock>='.zbx_dbstr($min).
+					' AND clock<='.zbx_dbstr($max).
 				' ORDER BY clock ASC, eventid ASC';
 		$result=DBselect($sql);
 		while($row=DBfetch($result)){
@@ -2973,7 +2973,7 @@
 
 		$sql = 'SELECT t.triggerid, t.value '.
 				' FROM trigger_depends d, triggers t '.
-				' WHERE d.triggerid_down='.$triggerid.
+				' WHERE d.triggerid_down='.zbx_dbstr($triggerid).
 					' AND d.triggerid_up=t.triggerid';
 
 		$result = DBselect($sql);
@@ -3056,7 +3056,7 @@
 		$functionid=trigger_get_N_functionid($expression,$function);
 		if(isset($functionid)){
 			$row=DBfetch(DBselect('select i.* from items i, functions f '.
-				' where i.itemid=f.itemid and f.functionid='.$functionid));
+				' where i.itemid=f.itemid and f.functionid='.zbx_dbstr($functionid)));
 			if($row)
 			{
 				$result=($flag == ZBX_FLAG_TRIGGER)?
Index: frontends/php/include/scripts.inc.php
===================================================================
--- frontends/php/include/scripts.inc.php	(revision 38884)
+++ frontends/php/include/scripts.inc.php	(working copy)
@@ -1,7 +1,7 @@
 <?php
 
 function get_script_by_scriptid($scriptid){
-	$sql = 'SELECT * FROM scripts WHERE scriptid='.$scriptid;
+	$sql = 'SELECT * FROM scripts WHERE scriptid='.zbx_dbstr($scriptid);
 
 	$rows = false;
 	if($res = DBSelect($sql)){
@@ -13,7 +13,7 @@
 function add_script($name,$command,$usrgrpid,$groupid,$access){
 	$scriptid = get_dbid('scripts','scriptid');
 	$sql = 'INSERT INTO scripts (scriptid,name,command,usrgrpid,groupid,host_access) '.
-				" VALUES ($scriptid,".zbx_dbstr($name).','.zbx_dbstr($command).",$usrgrpid,$groupid,$access)";
+				' VALUES ('.$scriptid.','.zbx_dbstr($name).','.zbx_dbstr($command).','.zbx_dbstr($usrgrpid).','.zbx_dbstr($groupid).','.zbx_dbstr($access).')';
 	$result = DBexecute($sql);
 	if($result){
 		$result = $scriptid;
@@ -35,18 +35,18 @@
 	$sql = 'UPDATE scripts SET '.
 				' name='.zbx_dbstr($name).
 				' ,command='.zbx_dbstr($command).
-				' ,usrgrpid='.$usrgrpid.
-				' ,groupid='.$groupid.
-				' ,host_access='.$access.
-			' WHERE scriptid='.$scriptid;
+				' ,usrgrpid='.zbx_dbstr($usrgrpid).
+				' ,groupid='.zbx_dbstr($groupid).
+				' ,host_access='.zbx_dbstr($access).
+			' WHERE scriptid='.zbx_dbstr($scriptid);
 
 	$result = DBexecute($sql);
 return $result;
 }
 
 function script_make_command($scriptid,$hostid){
-	$host_db = DBfetch(DBselect('SELECT dns,useip,ip FROM hosts WHERE hostid='.$hostid));
-	$script_db = DBfetch(DBselect('SELECT command FROM scripts WHERE scriptid='.$scriptid));
+	$host_db = DBfetch(DBselect('SELECT dns,useip,ip FROM hosts WHERE hostid='.zbx_dbstr($hostid)));
+	$script_db = DBfetch(DBselect('SELECT command FROM scripts WHERE scriptid='.zbx_dbstr($scriptid)));
 
 	if($host_db && $script_db){
 		$command = $script_db['command'];
